package com.google.appengine.api.datastore;

import com.google.gwt.user.client.rpc.SerializationException;
import com.google.gwt.user.client.rpc.SerializationStreamReader;
import com.google.gwt.user.client.rpc.SerializationStreamWriter;

/**
 * Custom serializer for datastore Key instances.
 * This implementation writes the encoded value of the Key, the appId, kind, name and id.
 * @author Bryce Cottam 
 *
 */
public class Key_CustomFieldSerializer
{
	
	public static Key instantiate(SerializationStreamReader reader) throws SerializationException
	{
		String encoded = reader.readString();
		return KeyFactory.stringToKey(encoded);
	}

	public static void serialize(SerializationStreamWriter writer, Key instance) throws SerializationException
	{
		writer.writeString(KeyFactory.keyToString(instance));
		writer.writeString(instance.getAppId());
		writer.writeString(instance.getKind());
		writer.writeString(instance.getName());
		writer.writeString(instance.getNamespace());
		writer.writeLong(instance.getId());
	}

	public static void deserialize(SerializationStreamReader reader, Key instance) throws SerializationException
	{
		// nothing really to do here, since the instantiate method already did our work for us.
		// and KeyFactory.stringToKey will do everything else.
		// we do, however, have to read in what we wrote before... and ignore it:
		String appId = reader.readString();
		String kind  = reader.readString();
		String name  = reader.readString();
		String namespace = reader.readString();
		long   id    = reader.readLong();
	}
	
}
