package com.google.appengine.api.datastore;

import java.io.Serializable;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * @author Bryce Cottam 
 *
 */
public class Link implements IsSerializable, Serializable, Comparable<Link>
{
	
	private final String value;
	
	public Link(String value)
	{
		this.value = value;
	}
	
	public String getValue()
	{
		return value;
	}
	
	public String toString()
	{
		return value;
	}
	
	public int compareTo(Link that)
	{
		return this.value.compareTo(that.value);
	}
	
	public boolean equals(Object obj)
	{
		boolean eq = false;
		if (obj instanceof Link)
		{
			Link that = (Link)obj;
			eq = this.value.equals(that.value);
		}
		
		return eq;
	}
	
	public int hashCode()
	{
		return value.hashCode();
	}
	
}
