package com.google.appengine.api.datastore;

import java.io.Serializable;

public class PhoneNumber implements Comparable<PhoneNumber>, Serializable
{
	public static final long serialVersionUID = 0x838b25ea8cccb73cL;
	private String number;
	
	private PhoneNumber() 
	{
		number = null;
	}
	
	public PhoneNumber(String number)
	{
		if (number == null)
		{
			throw new NullPointerException("number must not be null");
		}
		
		this.number = number;
	}
	
	public int hashCode()
	{
		return number.hashCode();
	}
	
	public boolean equals(Object obj)
	{
		if (this == obj)
		{
			return true;
		}
		else if (obj == null || obj.getClass() != this.getClass())
		{
			return false;
		}
		
		PhoneNumber that = (PhoneNumber) obj;
		return this.number.equals(that.number);
	}

	public int compareTo(PhoneNumber that)
	{
		return this.number.compareTo(that.number);
	}
	
	public String getNumber()
	{
		return number;
	}
	
}
