package com.google.appengine.api.datastore;

import java.io.Serializable;

public class PostalAddress implements Comparable<PostalAddress>, Serializable
{
    public static final long serialVersionUID = 0xf0dd4f1320665db9L;
	private String address;
	
	public PostalAddress(String address)
	{
		if(address == null)
		{
			throw new NullPointerException("address must not be null");
		}
		else
		{
			this.address = address;
		}
	}
	
	public int hashCode()
	{
		return address.hashCode();
	}
	
	public boolean equals(Object obj)
	{
		if (this == obj)
		{
			return true;
		}
		
		boolean equal = false;
		if (this.getClass() == obj.getClass())
		{
			PostalAddress that = (PostalAddress) obj;
			equal = this.address.equals(that.address);
		}
		
		return  equal;
	}
	
	public int compareTo(PostalAddress that)
	{
		return this.getAddress().compareTo(that.getAddress());
	}
	
	public String getAddress()
	{
		return address;
	}
	
}
