package com.google.appengine.api.datastore;

import java.io.Serializable;

public class Rating implements Serializable, Comparable<Rating>
{
	public static final long serialVersionUID = 0x509462d58704603L;
	public static final int MIN_VALUE = 0;
	public static final int MAX_VALUE = 100;
	
	private int rating;
	
	private Rating()
	{
		this(0);
	}
	public Rating(int rating)
	{
		this.rating = rating;
	}
	
	public int hashCode()
	{
		return rating;
	}
	
	public boolean equals(Object obj)
	{
		if (this == obj)
		{
			return true;
		}
		else if (obj == null || obj.getClass() != this.getClass())
		{
			return false;
		}
		
		Rating that = (Rating) obj;
		return this.rating == that.rating;
	}
	
	public int compareTo(Rating that)
	{
		return Integer.valueOf(this.rating).compareTo(Integer.valueOf(that.rating));
	}
	
	public int getRating()
	{
		return rating;
	}
	
}
