package com.google.appengine.api.datastore;

import java.io.Serializable;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * @author Bryce Cottam 
 *
 */
public class ShortBlob implements IsSerializable
{
	private byte[] bytes;
	
	public ShortBlob(byte[] bytes)
	{
		this.bytes = bytes;
	}
	
	public byte[] getBytes()
	{
		return bytes;
	}
	
	public String toString()
	{
		int size = bytes == null ? 0 : bytes.length;
		return getClass().getName() + " size: " + size;
	}
	
	public boolean equals(Object obj)
	{
		if (this == obj)
		{
			return true;
		}
		
		boolean eq = false;
		if (obj instanceof ShortBlob)
		{
			ShortBlob that = (ShortBlob) obj;
			byte[] thisBytes = this.getBytes();
			byte[] thatBytes = that.getBytes();
			
			if (thisBytes.length == thatBytes.length)
			{
				eq = true;
				for (int i = 0; i < thisBytes.length; i++)
				{
					if (thisBytes[i] != thatBytes[i])
					{
						eq = false;
						break;
					}
				}
			}
		}
		
		return eq;
	}
	
	public int hashCode()
	{
		return bytes.length;
	}

}
